import java.net.*;
import java.io.*;
import java.util.*;

public class PortRedirector extends Thread {

	public static void main(String[] args) throws IOException {

        new PortRedirector(Integer.parseInt(args[2]), args[1]);

//		int portNo = 20000;          // |[gԍ
		int portNo = Integer.parseInt(args[0]);          // |[gԍ
		ServerSocket serverSocket = null;
		Socket newSocket = null;
		try {
			try {
				//Mp̃\Pbg쐬
				serverSocket = new ServerSocket(portNo);
				String s = serverSocket.toString();
				System.out.println("Listen: " + s);
	
			} catch (IOException e) {
				System.err.println("Could not listen on port: " + portNo);
				System.exit(-1);
			}
			while (true) {
				newSocket = serverSocket.accept();
				System.out.println("Accepted.");
				new PortRedirector(newSocket).start();
			}
		} finally {
			if (null != serverSocket) {
				serverSocket.close();
			}
		}
    }

	private static int dstPort;
	private static String dstHost;
	public PortRedirector(int _dstPort, String _dstHost) {
		dstPort = _dstPort;
		dstHost = _dstHost;
	}

	// ------------ȉ͎MXbhɂȂ镔---------------------
	private Socket socket = null;
	byte[] buf = new byte[8760];

	public PortRedirector(Socket socket) throws IOException {
		this.socket = socket;
		System.out.println("Thread was created.");
    }

    public void run() {

//		String serverName = new String ("192.168.50.150");       // {̐ڑ
//		int serverPort = 20000;                             // {̐ڑ|[gԍ
		String serverName = dstHost;       // {̐ڑ
		int serverPort = dstPort;          // {̐ڑ|[gԍ
		// _~[̃\PbgA̐{ɂȂ
		Socket[] dummyS = new Socket[10];
		InputStream[] dummyIn = new InputStream[dummyS.length];
		OutputStream[] dummyOut = new OutputStream[dummyS.length];

		Socket serverS = null;
		InputStream serverIn = null;
		OutputStream serverOut = null;
		// {̐ڑɐڑ
		try {
			serverS = new Socket(serverName , serverPort);
		    serverS.setSoTimeout(1);
		    serverIn = serverS.getInputStream();
			serverOut = serverS.getOutputStream();
		} catch (Exception e){}

		// _~[\Pbg̐ڑ
		for (int i = 0 ; i < dummyS.length ; i++){
			try {
	    	    dummyS[i] = new Socket(serverName , serverPort);
			    dummyS[i].setSoTimeout(1);
				dummyIn[i] = dummyS[i].getInputStream();
				dummyOut[i] = dummyS[i].getOutputStream();
			} catch (Exception e){}
		}

		try {
			String sSocket = socket.toString();
			System.out.println("Connect: " + sSocket);
			logOut("Connect: " + sSocket);
		    socket.setSoTimeout(1);
			InputStream in = socket.getInputStream();
		    OutputStream out = socket.getOutputStream();
			while (true) {
				int n = 0;
			    try {
					n = in.read(buf);
				} catch (InterruptedIOException e){
//				    System.out.println ("^CAEg");
				}
				if (n == -1) break;
				if (n > 0){
					String buffer = new String();
	    			buffer = socket.getInetAddress().getHostAddress();
		    		buffer += " ";

			    	buffer += "port:" + socket.getPort() + " ";
			    	buffer +=  "size:" + n + " ";
//				buffer += new String(buf ,0, n);
//System.out.println(new String(buf ,0, n));
				    logOut (buffer);
				}

				// ɑ
				if (n > 0){
					serverOut.write(buf,0,n);

					// Ƀ_~[ɂ
				    for (int i = 0 ; i < dummyS.length ; i++){
						try {
							dummyOut[i].write (buf , 0 , n);
						} catch (Exception e){}
					}
				}

				// 肩̉󂯎
				int r = 0;
			    try {
					r = serverIn.read(buf);
				} catch (InterruptedIOException e){
//				    System.out.println ("^CAEg");
				}
				if (r == -1) break;
				if (r > 0){
				    // NCAgɑ
				    out.write(buf , 0 , r);
//System.out.println(new String(buf ,0, r));
				}

				// _~[ɑ΂鉞AƂ肠󂯂
				for (int i = 0 ; i < dummyS.length ; i++){
					try {
						dummyIn[i].read (buf);
					} catch (Exception e){}
				}
			}
			in.close();
		    out.close();
			socket.close();
			System.out.println("Disconnected: " + sSocket);
			logOut("Disconnected: " + sSocket);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	private void logOut (String str){

		// 擪Ɏt
		Calendar now = Calendar.getInstance();
		str =   now.get(Calendar.YEAR) + "/" + (now.get(Calendar.MONTH)+1) + "/" + now.get(Calendar.DAY_OF_MONTH) + " "
			    + now.get(Calendar.HOUR_OF_DAY) + ":" + now.get(Calendar.MINUTE) + ":" + now.get(Calendar.SECOND) + "." + now.get(Calendar.MILLISECOND)
			    + " \t" + str;
		// Ōɉst
		str += "\n";

		System.out.print (str);
	}
}